Package com.google.protobuf

# Class Enum

java.lang.Object
com.google.protobuf.AbstractMessageLite
com.google.protobuf.AbstractMessage
com.google.protobuf.GeneratedMessageV3
com.google.protobuf.Enum

All Implemented Interfaces:
  `EnumOrBuilder`, `Message`, `MessageLite`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `Serializable`

public final class Enum extends GeneratedMessageV3 implements EnumOrBuilder
Protobuf type `google.protobuf.Enum`

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static final class`
`Enum.Builder`
Protobuf type `google.protobuf.Enum`

## Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessageV3

`GeneratedMessageV3.BuilderParent, GeneratedMessageV3.ExtendableBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>,BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>, GeneratedMessageV3.ExtendableMessage<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>, GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>, GeneratedMessageV3.FieldAccessorTable, GeneratedMessageV3.UnusedPrivateParameter`

## Nested classes/interfaces inherited from class com.google.protobuf.AbstractMessageLite

`AbstractMessageLite.InternalOneOfEnum`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`ENUMVALUE_FIELD_NUMBER`
`static final int`
`NAME_FIELD_NUMBER`
`static final int`
`OPTIONS_FIELD_NUMBER`
`static final int`
`SOURCE_CONTEXT_FIELD_NUMBER`
`static final int`
`SYNTAX_FIELD_NUMBER`

### Fields inherited from class com.google.protobuf.GeneratedMessageV3

`alwaysUseFieldBuilders, unknownFields`

### Fields inherited from class com.google.protobuf.AbstractMessage

`memoizedSize`

### Fields inherited from class com.google.protobuf.AbstractMessageLite

`memoizedHashCode`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Compares the specified object with this message for equality.
`static Enum`
`getDefaultInstance()`
`Enum`
`getDefaultInstanceForType()`
Get an instance of the type with no fields set.
`static final Descriptors.Descriptor`
`getDescriptor()`
`EnumValue`
`getEnumvalue(int index)`
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`
`int`
`getEnumvalueCount()`
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`
`List<EnumValue>`
`getEnumvalueList()`
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`
`EnumValueOrBuilder`
`getEnumvalueOrBuilder(int index)`
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`
`List<? extends EnumValueOrBuilder>`
`getEnumvalueOrBuilderList()`
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`
`String`
`getName()`
`string name = 1 [json_name = "name"];`
`ByteString`
`getNameBytes()`
`string name = 1 [json_name = "name"];`
`Option`
`getOptions(int index)`
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`
`int`
`getOptionsCount()`
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`
`List<Option>`
`getOptionsList()`
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`
`OptionOrBuilder`
`getOptionsOrBuilder(int index)`
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`
`List<? extends OptionOrBuilder>`
`getOptionsOrBuilderList()`
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`
`Parser<Enum>`
`getParserForType()`
TODO(b/258340024): Remove this unnecessary intermediate implementation of this method.
`int`
`getSerializedSize()`
Get the number of bytes required to encode this message.
`SourceContext`
`getSourceContext()`
`.google.protobuf.SourceContext source_context = 4 [json_name = "sourceContext"];`
`SourceContextOrBuilder`
`getSourceContextOrBuilder()`
`.google.protobuf.SourceContext source_context = 4 [json_name = "sourceContext"];`
`Syntax`
`getSyntax()`
`.google.protobuf.Syntax syntax = 5 [json_name = "syntax"];`
`int`
`getSyntaxValue()`
`.google.protobuf.Syntax syntax = 5 [json_name = "syntax"];`
`int`
`hashCode()`
Returns the hash code value for this message.
`boolean`
`hasSourceContext()`
`.google.protobuf.SourceContext source_context = 4 [json_name = "sourceContext"];`
`protected GeneratedMessageV3.FieldAccessorTable`
`internalGetFieldAccessorTable()`
Get the FieldAccessorTable for this type.
`final boolean`
`isInitialized()`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`static Enum.Builder`
`newBuilder()`
`static Enum.Builder`
`newBuilder(Enum prototype)`
`Enum.Builder`
`newBuilderForType()`
Constructs a new builder for a message of the same type as this message.
`protected Enum.Builder`
`newBuilderForType(GeneratedMessageV3.BuilderParent parent)`
TODO(b/258340024): remove this together with GeneratedMessageV3.BuilderParent.
`protected Object`
`newInstance(GeneratedMessageV3.UnusedPrivateParameter unused)`
Creates a new instance of this message type.
`static Enum`
`parseDelimitedFrom(InputStream input)`
`static Enum`
`parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
`static Enum`
`parseFrom(byte[] data)`
`static Enum`
`parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry)`
`static Enum`
`parseFrom(ByteString data)`
`static Enum`
`parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry)`
`static Enum`
`parseFrom(CodedInputStream input)`
`static Enum`
`parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
`static Enum`
`parseFrom(InputStream input)`
`static Enum`
`parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
`static Enum`
`parseFrom(ByteBuffer data)`
`static Enum`
`parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry)`
`static Parser<Enum>`
`parser()`
`Enum.Builder`
`toBuilder()`
Constructs a builder initialized with the current message.
`void`
`writeTo(CodedOutputStream output)`
Serializes the message and writes it to `output`.

### Methods inherited from class com.google.protobuf.GeneratedMessageV3

`canUseUnsafe, computeStringSize, computeStringSizeNoTag, emptyBooleanList, emptyDoubleList, emptyFloatList, emptyIntList, emptyLongList, getAllFields, getDescriptorForType, getField, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof, internalGetMapField, isStringEmpty, makeExtensionsImmutable, makeMutableCopy, mergeFromAndMakeImmutableInternal, mutableCopy, mutableCopy, mutableCopy, mutableCopy, mutableCopy, newBooleanList, newBuilderForType, newDoubleList, newFloatList, newIntList, newLongList, parseDelimitedWithIOException, parseDelimitedWithIOException, parseUnknownField, parseUnknownFieldProto3, parseWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, serializeBooleanMapTo, serializeIntegerMapTo, serializeLongMapTo, serializeStringMapTo, writeReplace, writeString, writeStringNoTag`

### Methods inherited from class com.google.protobuf.AbstractMessage

`findInitializationErrors, getInitializationErrorString, hashBoolean, hashEnum, hashEnumList, hashFields, hashLong, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite

`addAll, addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.MessageLite

`toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

## Field Details

### NAME_FIELD_NUMBER

public static final int NAME_FIELD_NUMBER

See Also:
  - Constant Field Values

### ENUMVALUE_FIELD_NUMBER

public static final int ENUMVALUE_FIELD_NUMBER

See Also:
  - Constant Field Values

### OPTIONS_FIELD_NUMBER

public static final int OPTIONS_FIELD_NUMBER

See Also:
  - Constant Field Values

### SOURCE_CONTEXT_FIELD_NUMBER

public static final int SOURCE_CONTEXT_FIELD_NUMBER

See Also:
  - Constant Field Values

### SYNTAX_FIELD_NUMBER

public static final int SYNTAX_FIELD_NUMBER

See Also:
  - Constant Field Values

## Method Details

### newInstance

protected Object newInstance(GeneratedMessageV3.UnusedPrivateParameter unused)
Description copied from class: `GeneratedMessageV3`
Creates a new instance of this message type. Overridden in the generated code.

Overrides:
  `newInstance` in class `GeneratedMessageV3`

### getDescriptor

public static final Descriptors.Descriptor getDescriptor()

### internalGetFieldAccessorTable

protected GeneratedMessageV3.FieldAccessorTable internalGetFieldAccessorTable()
Description copied from class: `GeneratedMessageV3`
Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.

Specified by:
  `internalGetFieldAccessorTable` in class `GeneratedMessageV3`

### getName

public String getName()
`string name = 1 [json_name = "name"];`

Specified by:
  `getName` in interface `EnumOrBuilder`
Returns:
  The name.

### getNameBytes

public ByteString getNameBytes()
`string name = 1 [json_name = "name"];`

Specified by:
  `getNameBytes` in interface `EnumOrBuilder`
Returns:
  The bytes for name.

### getEnumvalueList

public List<EnumValue> getEnumvalueList()
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`

Specified by:
  `getEnumvalueList` in interface `EnumOrBuilder`

### getEnumvalueOrBuilderList

public List<? extends EnumValueOrBuilder> getEnumvalueOrBuilderList()
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`

Specified by:
  `getEnumvalueOrBuilderList` in interface `EnumOrBuilder`

### getEnumvalueCount

public int getEnumvalueCount()
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`

Specified by:
  `getEnumvalueCount` in interface `EnumOrBuilder`

### getEnumvalue

public EnumValue getEnumvalue(int index)
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`

Specified by:
  `getEnumvalue` in interface `EnumOrBuilder`

### getEnumvalueOrBuilder

public EnumValueOrBuilder getEnumvalueOrBuilder(int index)
`repeated .google.protobuf.EnumValue enumvalue = 2 [json_name = "enumvalue"];`

Specified by:
  `getEnumvalueOrBuilder` in interface `EnumOrBuilder`

### getOptionsList

public List<Option> getOptionsList()
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`

Specified by:
  `getOptionsList` in interface `EnumOrBuilder`

### getOptionsOrBuilderList

public List<? extends OptionOrBuilder> getOptionsOrBuilderList()
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilderList` in interface `EnumOrBuilder`

### getOptionsCount

public int getOptionsCount()
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`

Specified by:
  `getOptionsCount` in interface `EnumOrBuilder`

### getOptions

public Option getOptions(int index)
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`

Specified by:
  `getOptions` in interface `EnumOrBuilder`

### getOptionsOrBuilder

public OptionOrBuilder getOptionsOrBuilder(int index)
`repeated .google.protobuf.Option options = 3 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilder` in interface `EnumOrBuilder`

### hasSourceContext

public boolean hasSourceContext()
`.google.protobuf.SourceContext source_context = 4 [json_name = "sourceContext"];`

Specified by:
  `hasSourceContext` in interface `EnumOrBuilder`
Returns:
  Whether the sourceContext field is set.

### getSourceContext

public SourceContext getSourceContext()
`.google.protobuf.SourceContext source_context = 4 [json_name = "sourceContext"];`

Specified by:
  `getSourceContext` in interface `EnumOrBuilder`
Returns:
  The sourceContext.

### getSourceContextOrBuilder

public SourceContextOrBuilder getSourceContextOrBuilder()
`.google.protobuf.SourceContext source_context = 4 [json_name = "sourceContext"];`

Specified by:
  `getSourceContextOrBuilder` in interface `EnumOrBuilder`

### getSyntaxValue

public int getSyntaxValue()
`.google.protobuf.Syntax syntax = 5 [json_name = "syntax"];`

Specified by:
  `getSyntaxValue` in interface `EnumOrBuilder`
Returns:
  The enum numeric value on the wire for syntax.

### getSyntax

public Syntax getSyntax()
`.google.protobuf.Syntax syntax = 5 [json_name = "syntax"];`

Specified by:
  `getSyntax` in interface `EnumOrBuilder`
Returns:
  The syntax.

### isInitialized

public final boolean isInitialized()
Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

Specified by:
  `isInitialized` in interface `MessageLiteOrBuilder`
Overrides:
  `isInitialized` in class `GeneratedMessageV3`

### writeTo

public void writeTo(CodedOutputStream output) throws IOException
Description copied from interface: `MessageLite`
Serializes the message and writes it to `output`. This does not flush or close the stream.

Specified by:
  `writeTo` in interface `MessageLite`
Overrides:
  `writeTo` in class `GeneratedMessageV3`
Throws:
  `IOException`

### getSerializedSize

public int getSerializedSize()
Description copied from interface: `MessageLite`
Get the number of bytes required to encode this message. The result is only computed on the first call and memoized after that. If this message requires more than Integer.MAX_VALUE bytes to encode, the return value will be smaller than the actual number of bytes required and might be negative.

Specified by:
  `getSerializedSize` in interface `MessageLite`
Overrides:
  `getSerializedSize` in class `GeneratedMessageV3`

### equals

public boolean equals(Object obj)
Description copied from interface: `Message`
Compares the specified object with this message for equality. Returns `true` if the given object is a message of the same type (as defined by `getDescriptorForType()`) and has identical values for all of its fields. Subclasses must implement this; inheriting `Object.equals()` is incorrect.

Specified by:
  `equals` in interface `Message`
Overrides:
  `equals` in class `AbstractMessage`
Parameters:
  `obj` - object to be compared for equality with this message
Returns:
  `true` if the specified object is equal to this message

### hashCode

public int hashCode()
Description copied from interface: `Message`
Returns the hash code value for this message. The hash code of a message should mix the message's type (object identity of the descriptor) with its contents (known and unknown field values). Subclasses must implement this; inheriting `Object.hashCode()` is incorrect.

Specified by:
  `hashCode` in interface `Message`
Overrides:
  `hashCode` in class `AbstractMessage`
Returns:
  the hash code value for this message
See Also:
  - `Map.hashCode()`

### parseFrom

public static Enum parseFrom(ByteBuffer data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Enum parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Enum parseFrom(ByteString data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Enum parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Enum parseFrom(byte[] data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Enum parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Enum parseFrom(InputStream input) throws IOException

Throws:
  `IOException`

### parseFrom

public static Enum parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### parseDelimitedFrom

public static Enum parseDelimitedFrom(InputStream input) throws IOException

Throws:
  `IOException`

### parseDelimitedFrom

public static Enum parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### parseFrom

public static Enum parseFrom(CodedInputStream input) throws IOException

Throws:
  `IOException`

### parseFrom

public static Enum parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### newBuilderForType

public Enum.Builder newBuilderForType()
Description copied from interface: `MessageLite`
Constructs a new builder for a message of the same type as this message.

Specified by:
  `newBuilderForType` in interface `Message`
Specified by:
  `newBuilderForType` in interface `MessageLite`

### newBuilder

public static Enum.Builder newBuilder()

### newBuilder

public static Enum.Builder newBuilder(Enum prototype)

### toBuilder

public Enum.Builder toBuilder()
Description copied from interface: `MessageLite`
Constructs a builder initialized with the current message. Use this to derive a new message from the current one.

Specified by:
  `toBuilder` in interface `Message`
Specified by:
  `toBuilder` in interface `MessageLite`

### newBuilderForType

protected Enum.Builder newBuilderForType(GeneratedMessageV3.BuilderParent parent)
Description copied from class: `GeneratedMessageV3`
TODO(b/258340024): remove this together with GeneratedMessageV3.BuilderParent.

Specified by:
  `newBuilderForType` in class `GeneratedMessageV3`

### getDefaultInstance

public static Enum getDefaultInstance()

### parser

public static Parser<Enum> parser()

### getParserForType

public Parser<Enum> getParserForType()
Description copied from class: `GeneratedMessageV3`
TODO(b/258340024): Remove this unnecessary intermediate implementation of this method.

Specified by:
  `getParserForType` in interface `Message`
Specified by:
  `getParserForType` in interface `MessageLite`
Overrides:
  `getParserForType` in class `GeneratedMessageV3`

### getDefaultInstanceForType

public Enum getDefaultInstanceForType()
Description copied from interface: `MessageLiteOrBuilder`
Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.

Specified by:
  `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
Specified by:
  `getDefaultInstanceForType` in interface `MessageOrBuilder`